import threading
import thread
import time

# python2.1 compatibility
try:
    import True
except:
    True = 1
    False = 0


DEFAULT_TIMEOUT=3600  # The expiration time for the cache - 1 hour by default

class CacheObject:

    def __init__(self, **kw):
        self.created = time.time()
        self.setData(kw)

    def setData(self, data):
        self.data = data

    def __getitem__(self, key):
        return self.data[key]

class ReportCache:

    def __init__(self, timeout=DEFAULT_TIMEOUT):
        self.timeout = timeout
        self.reportinfo = {}
        self._lock = threading.Lock()

    def _isValid(self, dict):
        if dict is None:
            return False
        cache_time = dict['time']
        now = time.time()
        if cache_time + self.timeout > now :
            return True
        return False

    def getReportInfo(self, default=None):
        val = self.reportinfo
        if val is not None:
            return val
        return default

    def cacheReportInfo(self, data):
        self._lock.acquire()
        for key, value in data.items():
            self.reportinfo[key] = value
            self.reportinfo[key].update({'time':time.time()})
        self._lock.release()

    def invalidate(self):
        self._lock.acquire()
        self.reportinfo = None
        self._lock.release()